<?php
/* 
 * Plugin Name: Dadi Breadcrumb 
 * Plugin URI: http://www.iljester.it/plugins/dadifb-breadcrum/
 * Description: Set and manage your custom breadcrumb for each post and post type
 * Version: 1.1.2
 * Author: Davide Mura
 * Author URI: http://www.iljester.it/davide/
 */
	/*  Copyright 2016 DAVIDE MURA  (email: muradavi@gmail.com)

		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License, version 2, as 
		published by the Free Software Foundation.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	*/
/*
 * 
 *********************************************************************************/
	
/*
 * Deny directly access to this file. Redirect to status 403 forbidden
 * 
 * For @param and @return see http://php.net/manual/en/function.header.php
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19 
 */
if ( !function_exists('is_admin') ) {
	header('Status: 403 Forbidden');
	header('HTTP/1.1 403 Forbidden');
	exit;
}


/*  
 * Define constants
 * 
 * For reference (@param and @return) see: http://php.net/manual/en/function.define.php
 * 
 */
define( "DADIBD_DIR", plugin_dir_path( __FILE__ ) );
define( "DADIBD_URL", plugin_dir_url( __FILE__ ) );
define( 'DADIBD_BASENAME', plugin_basename( __FILE__ ) );
define( 'DADIBD_DOMAIN', 'dadibd' );
define( 'DADIBD_HOST_DOMAIN', $_SERVER['HTTP_HOST'] );


/*
 * Includes require files
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
// includes options form
require_once DADIBD_DIR . 'dadibd-options.php';
// includes metabox
require_once DADIBD_DIR . 'dadibd-metabox.php';
// includes class for build breadcrumb
require_once DADIBD_DIR . 'dadibd-preclass-functions.php';
// includes class for build breadcrumb
require_once DADIBD_DIR . 'dadibd-class.php';
// includes functions for output
require_once DADIBD_DIR . 'dadibd-output-functions.php';


/*
 * Set languages directory
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/load_plugin_textdomain/
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
function dadibd_load_textdomain() {
  load_plugin_textdomain( DADIBD_DOMAIN, false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' ); 
}
add_action( 'plugins_loaded', 'dadibd_load_textdomain' );


/*
 * Load stylesheet for settings page
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/wp_enqueue_style/
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
function dadibd_load_admin_styles() {
	wp_enqueue_style('dadibd-style-settings', DADIBD_URL . 'css/dadibd-settings.css');
}
add_action( 'admin_enqueue_scripts', 'dadibd_load_admin_styles' );


/*
 * Load default stylesheet for frontend breadcrumb
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/wp_enqueue_style/
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19 
 */
function dadibd_add_scripts_and_styles() {
	wp_enqueue_style('dadibd-style', DADIBD_URL . 'css/dadibd.css');
}
add_action( 'wp_enqueue_scripts', 'dadibd_add_scripts_and_styles' );


/*
 * Load jQuery script in local settings file
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/wp_enqueue_script/
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
function dadibd_add_jquery_library( $hook ) {
	
	if( 'dadibd-core.php' != $hook ) return;
	
	wp_enqueue_script('jquery');
}
add_action( 'wp_enqueue_scripts', 'dadibd_add_jquery_library' );


/*
 * Add the option page
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/add_options_page/
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
function dadibd_add_option_page() {
	add_options_page('Dadi Breadcrumb', 'Dadi Breadcrumb', 'administrator', 'dadibd-options-page', 'dadibd_update_options_form');
}
add_action('admin_menu', 'dadibd_add_option_page');


/*
 * Add options into plugin
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/add_option/
 * https://developer.wordpress.org/reference/functions/register_activation_hook/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19 
 */
function add_dadibd_option() {
	
	add_option( 'all_visible', false );
	add_option( 'auto_append_breadcrumb', 0 );
	add_option( 'target_element_to_append', '' );
	add_option( 'type_of_position', 'prepend' );
	add_option( 'virtual_dir', '' );
	add_option( 'format_date', 'Y/m/d' );
	add_option( 'position_date', 0 );
	add_option( 'date_element', 'day' );
	add_option( 'nolink_date', true );
	add_option( 'radio_icon', 'none' );
	add_option( 'home_icon', '' );
	add_option( 'custom_sep', 0 );
	add_option( 'disable_css', false );
	add_option( 'cut_this_title', 0 );
	add_option( 'switch_twenty_theme_style', 'tw-sixteen' );
	add_option( 'author_name', 'author_full_name' );
	add_option( 'custom_post_type_name_link', false );
	foreach( get_dadibd_list_post_type() as $post_type ) {
		
		add_option( $post_type . '_display_date', false );
		add_option( $post_type . '_categories', false );
		add_option( $post_type . '_get_taxonomies', '' );
		add_option( $post_type . '_no_default_category', false );
		add_option( $post_type . '_no_parent_category', false );
		
	}
	add_option( 'post_types_exclude', '' );
	
}
register_activation_hook( __FILE__, 'add_dadibd_option' );


/*
 * 
 * Register settings
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/register_setting/
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 * 
 */
function dadibd_register_options_group() {
	register_setting( 'dadibd_options_group', 'dadibd_options', 'dadibd_validate_input' );
}
add_action ( 'admin_init', 'dadibd_register_options_group' );


/*
 * 
 * Array for default options value when click resetting button
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 * 
 */
$default = array(
	'all_visible'						=> false,
	'auto_append_breadcrumb'		 	=> 0,
	'target_element_to_append'			=> '',
	'type_of_position'					=> 'prepend',
	'virtual_dir'						=> '',
	'format_date'						=> 'Y/m/d',
	'position_date'						=> 0,
	'date_element'						=> 'day',
	'nolink_date'						=> false,
	'radio_icon'						=> 'none',
	'home_icon'							=> '',
	'custom_sep'						=> 0,
	'disable_css'						=> false,
	'cut_this_title'					=> 0,
	'author_name'						=> 'author_full_name',
	'custom_post_type_name_link'		=> false,
	'post_types_exclude'				=> '',
);


/*
 * Add to $default array default taxonomies and default values for post types that needs
 * to be defined after wordpress has inizialized some routines
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 * 
 */
function get_dadibd_default_taxonomies_to_reset(){
	
	global $default;
	
	$count = 1;
	
	foreach( get_dadibd_list_post_type() as $post_type ) {
		
		// add display date values
		$default[$post_type . '_display_date']				= false;
		
		$custom_taxonomies = get_object_taxonomies( $post_type );
		
		foreach( $custom_taxonomies as $tax ) {
			
			$default[$post_type . '_categories'] 			= false;
			$default[$post_type . '_no_default_category'] 	= false;
			$default[$post_type . '_no_parent_category'] 	= false;
			$default[$post_type . '_get_taxonomies'] 		= $tax;
			
			// stop loop when catched first occurrence that return true (is necessary for x_get_taxonomies).
			if( is_taxonomy_hierarchical( $tax ) == true ) break;
			
		}
		
	}

}
add_action ('admin_init','get_dadibd_default_taxonomies_to_reset', 199);


/*
 * Some other arrays for some inputs has needs to be defined 
 * after wordpress has initalized its routines. I.E. translations
 * 
 * For reference (@param and @return) see: 
 * https://developer.wordpress.org/reference/functions/add_action/
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
function get_dadibd_global_array_inputs() {
	
	$global_array_inputs = array(
		// radio icons for set type icon for home link
		'radio_icons' => array( 
			'ri_none' => array(
				'value' => 'none',
				'label'	=> __( 'None', 'dadibd' ),
			),
			'ri_image' => array(
				'value' => 'image',
				'label'	=> __( 'Image', 'dadibd' ),
			),
			'ri_glyphicon' => array(
				'value'	=> 'glyphicon',
				'label' => __( 'Glyphicon', 'dadibd' ),
			),
		),
		// define type link 
		'date_elements' => array(
			'de_year' => array(
				'value' => 'year',
				'label'	=> __( 'Year', 'dadibd' ),
			),
			'de_month' => array(
				'value' => 'month',
				'label'	=> __( 'Month', 'dadibd' ),
			),
			'de_day' => array(
				'value'	=> 'day',
				'label' => __( 'Day', 'dadibd' ),
			),
		),
		// set type of author name
		'author_type_names' => array( 
			'atn_full' => array(
				'value' => 'author_full_name',
				'label'	=> __( 'Author Full Name', 'dadibd' ),
			),
			'atn_nick' => array(
				'value'	=> 'day',
				'label' => __( 'Author Nickname', 'dadibd' ),
			),
		),
	);
	
	return $global_array_inputs;
}
add_action( 'admin_init', 'get_dadibd_global_array_inputs', 199 );


/*
 * Array to get type of position for breadcrumb that using jquery option
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
$jquery_positions = array( 
	'prepend', 
	'append', 
	'before', 
	'after' 
);


/*
 * Array to get symbols to use for sepators
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
$separators = array( 
	'&raquo;', 
	'&laquo;', 
	'>', 
	'<', 
	'>>', 
	'<<', 
	'&bull;', 
	'&#9632;',
	'&#9642;', 
	'|', 
	'/',
	'\\',
	'//',
	'\\\\',
	'-', 
	'_',
	'+',
	':',
	'::',
	'&larr;',
	'&rarr;',
	'&lArr;',
	'&rArr;',
	'&#9656;',
	'&#9657;',
	'&loz;'
);


/*
 * Array to exclude post type to manage in dadi breadcrumb options page
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 */
$post_types_exclude = array();


/*
 * 
 * Remove illegal chars for jQuery script used to display breadcrumb
 * 
 * @param: $pattern
 * @return: string
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 * 
 */
function filter_dadibd_illegal_chars( $pattern ) {
	
	$search = "/([^a-zA-Z0-9\-_\.#: ]+)/i";
	
	// delete illegal chars
	$target_element = preg_replace( $search, "", $pattern );
	
	// remove multiple chars and add space
	$target_element = preg_replace( "/(\.|#|\s)+/", " $1", $target_element );
	
	// remove spaces from border of new string
	$target_element = trim($target_element);

	return $target_element;
	
}


/*
 * Filter date setting
 *  
 * This is a function that filter format date removing all not allowed chars
 * 
 * @param: 		$date
 * @return: 	string
 * 
 * @package 	Dadi Breadcrumb
 * @since 		Since Release 1.0
 * @version 	1.0 2016/05/19
 */
function filter_dadibd_date( $date = 'Y/m/d' ) {
	
	// select only these chars for the format date
	preg_match("/[jdFMmnYy\.\-_\/\|\s]+/", $date, $matches );
	
	// remove multiple chars
	$date = preg_replace("/(j|d|F|M|m|n|Y|y)+(\.\-|_|\/|\||\s)*/", "$1$2", $matches[0] );
	
	// remove space from borders
	$date = trim( $date );
	
	// now we count string length: must be 5 or < 5
	$count_chars_string = strlen( $date );
	
	if( $count_chars_string > 5 ) {

		// we get a negative number
		$cut = 5 - $count_chars_string;

		// we remove all chars over 5
		$date = substr( $date, 0, $cut );
		
	}
	
	return $date;
	
}


/*
 * Match date format to date link
 *  
 * This is a function that match date format to date link and print error message
 * @param: 		$date, $date_element
 * @return: 	string
 * 
 * @package 	Dadi Breadcrumb
 * @since 		Since Release 1.0
 * @version 	1.0 2016/05/19 
 */
function get_dadibd_message_date_errors( $date, $date_element ) {
	
	$day = preg_match( "/[dj]+/i", $date );
	$mon = preg_match( "/[FMmn]+/i", $date );
	$yea = preg_match( "/[Yy]+/i", $date );

	$type_link = $date_element;
	
	$msg = __( 'Warning! The date format is not match to date link. Verify your date format or change your date link.', 'dadibd' );

	if( $type_link == 'day') { 
			
		if( $day === 1 && $mon === 1 && $yea === 1 ) {
			
			$message = '';
			
		} else {
			
			$message = '<span class="dadibd-warning">' . $msg . '</span>';
		}

	} elseif ( $type_link == 'month' ) {

		if( $day === 0 && $mon === 1 && $yea === 1 ) {
			
			$message = '';
			
		} else {
			
			$message = '<span class="dadibd-warning">' . $msg . '</span>';
		}


	} elseif( $type_link == 'year') {


		if( $day === 0 && $mon === 0 && $yea === 1 ) {
			
			$message = '';
			
		} else {
			
			$message = '<span class="dadibd-warning">' . $msg . '</span>';
		
		}


	}
	
	return $message;
		
}


/*
 * 
 * Filter virtual dir
 *  
 * This is a function that filter virtual dir removing disallowed chars
 * @param: 		$dir
 * @return: 	string
 * 
 * @package 	Dadi Breadcrumb
 * @since 		Since Release 1.0
 * @version 	1.0 2016/05/19
 * 
 */
function filter_dadibd_virtual_dir( $dir ) {
	
	$regex = "/([^\w\d\-_'&àáâäåæèéêëìíîïòóôöùúûüçñ ]+)/";
	$new_dir = preg_replace( $regex, "", $dir );
	
	return $new_dir;
	
}


/*
 * 
 * Get list of post types
 *  
 * This is a function that get all post types public builtin and custom
 * @param: 		none
 * @return: 	array
 * 
 * @package 	Dadi Breadcrumb
 * @since 		Since Release 1.0
 * @version 	1.0 2016/05/19
 * 
 */
function get_dadibd_list_post_type() {
	
	// get builtin
	$args = array(
	   'public'   => true,
	   '_builtin' => true
	);
							
	$posts = get_post_types( $args );
	
	// get custom
	$args = array(
	   'public'   => true,
	   '_builtin' => false
	);
							
	$custs = get_post_types( $args );
	
	// we merge the arrays
	$post_types = array_merge( $posts + $custs );
	
	if( get_dadibd_options( 'post_types_exclude' ) != '' ) {
	
		// get excludes post_types
		$pt_excludes = explode( '|', get_dadibd_options( 'post_types_exclude' ) );
		$trimmed_pt_excludes = array_map( 'trim' , $pt_excludes );
		
		// build new array
		$new_post_types = array_diff( $post_types, $trimmed_pt_excludes );
		
		return $new_post_types;
		
	}
	else {
		
		return $post_types;
		
	}
	
}


/*
 * 
 * Return data setting for breadcrumb
 *  
 * This is a function that returns data everywhere is called
 * @param: $options
 * @return: mixed values (bool|string|int)
 * 
 * @package Dadi Breadcrumb
 * @since Since Release 1.0
 * @version 1.0 2016/05/19
 * 
 */
function get_dadibd_options( $options ) {
	
	global $default;
	
	$option = get_option('dadibd_options', $default );
	
	// void|null return if is unset $options
	if( !isset( $option[ $options ]  ) ) return;
	
	return $option[ $options ];

}
